# ken: super-rich components for Flutter applications

![ken Logo](https://github.com/smeup/ken/blob/develop/assets/images/logo_KEN.png)

[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)

## Intro

Ken is a mobile components library for [Flutter](https://flutter.dev/) applicaiton.

## Showcase

Go to [ken Showcase](https://github.com/smeup/ken-showcase).

## ken API

- Check out our [API](https://github.com/smeup/ken/blob/develop/doc/api/index.md)

## ken Development

- [Dependencies](https://github.com/smeup/ken/blob/develop/doc/development/dependencies.md)
- [Widgets](https://github.com/smeup/ken/blob/develop/doc/development/widgets.md)

## How to use ken in your project

Create a new Flutter app:
    
    > flutter create myapp

To install the ken library, add the following dependency:

    dependencies:
        ken: ^0.0.1+2

Add the ken library initilization in the main.dart file. In the initialization statement, you can set many attributes. Follow a minimal configuration:

    SmeupConfigurationService.init(
        context,
    );


## Contributing


## Issues

If you run into an error or an unexpected behavior, or you just want to give us feedback on how to improve, feel free to use the [issues](https://github.com/smeup/ken/issues) page.
